set terminal pdfcairo dashed font "Palatino, 10" enhanced lw 1 dl 1 size 4,2.7
#set terminal pdfcairo dashed enhanced size 4.9,3.1
set style fill transparent solid 0.25 noborder
set macros

gr='rgbcolor "#aaaaaa"'
bl='rgbcolor "#444444"'
p ='rgbcolor "#cc33cc"'
g ='rgbcolor "#33cc33"'
dg='rgbcolor "#119911"'
b ='rgbcolor "#2277ff"'
y ='rgbcolor "#ffdd11"'
dy='rgbcolor "#ffbb11"'
r ='rgbcolor "#ff4433"'
re='rgbcolor "#ff4433"'
w ='rgbcolor "#ffffff"'
br='rgbcolor "#964B00"'
set style lines 1 lc @bl lw 2 dt 2
set style lines 2 lc @g  lw 2 dt "_"
set style lines 3 lc @b  lw 2 dt 4
set style lines 4 lc @r  lw 2 dt 1
set style lines 5 lc @dy lw 2 dt "._."


proc='ggH'
muRs='0.5'

set title 'Higgs production in gluon fusion at LHC 13 TeV, m_H = 125 GeV'

set output 'plots/'.proc.'_distributions.pdf'
set xlabel '{/Symbol S} = cross section  [pb]'
set ylabel 'Probability distribution of the cross section: P({/Symbol S})'
set xrange [0:70]
set mxtics 5
set key top left Left reverse

set label 1 '{/Symbol m} = '.muRs.' Q'   at graph 0.8,0.8
file = 'output/'.proc.'_P_Sigma_np1_muR'.muRs.'.dat'

set yrange [0:*]
set label 2 'Geometric behaviour model' at graph 0.05,0.45
plot file u 1:2  ls  1 w l title 'given LO', \
     ''   u 1:5  ls  2 w l title 'given NLO', \
     ''   u 1:8  ls  3 w l title 'given NNLO', \
     ''   u 1:11 ls  4 w l title 'given N3LO', \
     ''   u 1:14 ls  5 w l title 'given N4LO', \
#


set yrange [0:*]
set label 2 'Scale variation model'
plot file u 1:3  ls  1 w l title 'given LO', \
     ''   u 1:6  ls  2 w l title 'given NLO', \
     ''   u 1:9  ls  3 w l title 'given NNLO', \
     ''   u 1:12 ls  4 w l title 'given N3LO', \
     ''   u 1:15 ls  5 w l title 'given N4LO', \
#

set yrange [0:*]
set label 2 'Custom model'
plot file u 1:4  ls  1 w l title 'given LO', \
     ''   u 1:7  ls  2 w l title 'given NLO', \
     ''   u 1:10 ls  3 w l title 'given NNLO', \
     ''   u 1:13 ls  4 w l title 'given N3LO', \
     ''   u 1:16 ls  5 w l title 'given N4LO', \
#



set label 1 '{/Symbol m} independent'  at graph 0.8,0.8
file = 'output/'.proc.'_P_Sigma_np1_muRindep.dat'

set yrange [0:*]
set label 2 'Geometric behaviour model' at graph 0.05,0.45
plot file u 1:2  ls  1 w l title 'given LO', \
     ''   u 1:5  ls  2 w l title 'given NLO', \
     ''   u 1:8  ls  3 w l title 'given NNLO', \
     ''   u 1:11 ls  4 w l title 'given N3LO', \
     ''   u 1:14 ls  5 w l title 'given N4LO', \
#


set yrange [0:*]
set label 2 'Scale variation model'
plot file u 1:3  ls  1 w l title 'given LO', \
     ''   u 1:6  ls  2 w l title 'given NLO', \
     ''   u 1:9  ls  3 w l title 'given NNLO', \
     ''   u 1:12 ls  4 w l title 'given N3LO', \
     ''   u 1:15 ls  5 w l title 'given N4LO', \
#

set yrange [0:*]
set label 2 'Custom model'
plot file u 1:4  ls  1 w l title 'given LO', \
     ''   u 1:7  ls  2 w l title 'given NLO', \
     ''   u 1:10 ls  3 w l title 'given NNLO', \
     ''   u 1:13 ls  4 w l title 'given N3LO', \
     ''   u 1:16 ls  5 w l title 'given N4LO', \
#





quit
