set terminal pdfcairo dashed font "Palatino, 10" enhanced lw 1 dl 1 size 4,2.7
#set terminal pdfcairo dashed enhanced size 4.9,3.1
set style fill transparent solid 0.25 noborder
set macros

gr='rgbcolor "#aaaaaa"'
bl='rgbcolor "#444444"'
p ='rgbcolor "#cc33cc"'
g ='rgbcolor "#33cc33"'
dg='rgbcolor "#119911"'
b ='rgbcolor "#2277ff"'
y ='rgbcolor "#ffdd11"'
dy='rgbcolor "#ffbb11"'
r ='rgbcolor "#ff4433"'
re='rgbcolor "#ff4433"'
w ='rgbcolor "#ffffff"'
set style lines 1 lc @bl lw 2 dt 2
set style lines 2 lc @g  lw 2 dt "_"
set style lines 3 lc @b  lw 2 dt 4
set style lines 4 lc @r  lw 2 dt 1
set style lines 5 lc @dy lw 2 dt "._."



proc='ggH'

file = 'output/'.proc.'_scale_dependence.dat'

set output 'plots/'.proc.'_scale_dependence.pdf'
set xlabel '{/Symbol m}/m_H'
set ylabel '{/Symbol S} = cross section  [pb]'
set xrange [0.02:100]
set xrange [0.0206174:100]
#set xrange [0.015625:128]
set logscale x
set xtics add("2"  2)
set xtics add("0.5"0.5)
set xtics add("0.25"0.25)

set title 'Higgs production in gluon fusion at LHC 13 TeV, m_H = 125 GeV'


set yrange [0:70]
plot file u 1:2  ls 1 w l title 'LO', \
     ''   u 1:3  ls 2 w l title 'NLO', \
     ''   u 1:4  ls 3 w l title 'NNLO', \
     ''   u 1:5  ls 4 w l title 'N3LO', \
#






