#include "AlphaStrong.hh"

using namespace std;


AlphaStrong::~AlphaStrong() {
  if(fmu!=NULL) delete[] fmu;
  if(fas!=NULL) delete[] fas;
}


//const double mZ = 91.1876;
//const double asZ = 0.118;
void AlphaStrong::alphas_nf5(double step, int n, int n0) {  // from ihixs
  int porder = fnloops-1;
  double as0 = falphas_mu0;
  //double mu0 = fmu0;
  //
  // Nf = 5 **************** <--------- IMPROVE THIS WITH A VFNS RUNNING
  double bb0 = 1.916666667;
  double bb1 = 1.260869565;
  double bb2 = 1.474788647;
  double bb3 = 9.835916431;
  double bb4 = 7.931967391;
  //
  double as;
  as0 /= M_PI;
  //double as0 = asZ/M_PI;
  //double as0=asZ/3.1415926;
  //double Mz=91.187;
  //
  //int N = 30000;
  //int N = int(20*exp(fabs(log(mu/mu0)))); // to be tested!
  //
  //double step = 2.*log(mu/mu0)/N, incr;
  double incr;
  for (int i=0; i<n; i++) {
    if (porder >= 4)
      incr = step*bb0*as0*as0*(1+bb1*as0 + bb2*as0*as0 + bb3*as0*as0*as0 + bb4*as0*as0*as0*as0 );
    if (porder == 3)
      incr = step*bb0*as0*as0*(1+bb1*as0 + bb2*as0*as0 + bb3*as0*as0*as0 );
    else if (porder == 2)
      incr = step*bb0*as0*as0*(1+bb1*as0 + bb2*as0*as0 );
    else if (porder == 1)
      incr = step*bb0*as0*as0*(1+bb1*as0);
    else if (porder == 0)
      incr = step*bb0*as0*as0;
    as = as0 - incr;
    as0 = as;
    fmu[n0+(i+1)*sign(step)] = fmu[n0+i*sign(step)]*exp(step/2);
    fas[n0+(i+1)*sign(step)] = as*M_PI;
  }
  return;
}
void AlphaStrong::init() {
  fmu_min = 0.4;
  double mu_max = 1e5;
  fnpoints = 2e4;
  if(fmu!=NULL) delete[] fmu;
  if(fas!=NULL) delete[] fas;
  fmu = new double[fnpoints];
  fas = new double[fnpoints];
  //cout << fmu0 << "  " << fmu0/mu_max << endl;
  double s = 2.*log(mu_max/fmu_min)/(fnpoints+0.); // desired step, to be tuned
  int n1 = int(2*log(fmu0/fmu_min) / s);
  //cout << n1 << endl;
  int n2 = fnpoints - n1-1;
  fstep = 2.*log(fmu_min/fmu0)/n1;
  fmu[n1] = fmu0;
  fas[n1] = falphas_mu0;
  alphas_nf5( fstep, n1, n1);
  alphas_nf5(-fstep, n2, n1);
  //for(int i=0; i<fnpoints; i++) cout << i << setw(12) << fmu[i] << setw(16) << fas[i] << endl;
  finitialized = true;
}
double AlphaStrong::alphas(double mu) {
  if(finitialized == false) { cout << "Alpha Strong not initialized" << endl; exit(-34); }
  if(mu < fmu[0] || mu > fmu[fnpoints-1]) {
    cout << "\033[0;31m" << "ERROR: Alpha Strong requested at scale mu = " << mu << " GeV  which is outside of interpolation range [" << fmu[0] << ", " << fmu[fnpoints-1] << "]" << "\033[0m" << endl;
    exit(22);
  }
  int k = int(-2*log(mu/fmu_min) / fstep);
  if(k==fnpoints-1) k--;
  //
  //double as = fas[k] + (fas[k+1]-fas[k]) * log(mu/fmu[k])/log(fmu[k+1]/fmu[k]);
  //cout << k << "   " << fmu[k] << " < " << mu << " < " << fmu[k+1] << endl;
  //cout << k << "   " << fas[k] << " > " << as << " > " << fas[k+1] << endl;
  //return as;
  return fas[k] + (fas[k+1]-fas[k]) * log(mu/fmu[k])/log(fmu[k+1]/fmu[k]);
}



