#pragma once

#include <cmath>
#include <cstdlib>
#include <iostream>
#include <fstream>

#include "common.hh"

using namespace std;


inline double beta0(int nf) { return (33.-2.*nf)/12.; }
inline double beta1(int nf) { return (153.-19.*nf)/24.; }
inline double beta2(int nf) { return (2857. - 5033./9.*nf + 325./27.*nf*nf)/128.; }
inline double beta3(int nf) { return (29243.0 - 6946.30*nf + 405.089*nf*nf + 1.49931*nf*nf*nf) / 256.; }
inline double beta4(int nf) { return 524.56 - 181.8*nf + 17.16*nf*nf - 0.22586*nf*nf*nf -0.0017993*nf*nf*nf*nf; }


class AlphaStrong {

public:
  // so far nf is fixed to 5 !!!!!!
  AlphaStrong(int nloops, double mu0, double alphas_mu0, int nf_mu0) : fnloops(nloops), fmu0(mu0), falphas_mu0(alphas_mu0), fnf_mu0(nf_mu0), finitialized(false), fmu(NULL), fas(NULL) { init(); }
  ~AlphaStrong();

  void init();
  double alphas(double mu);

private:
  int fnloops;
  double fmu0;
  double falphas_mu0;
  int fnf_mu0;
  bool finitialized;
  int fnpoints;
  double *fmu, *fas, fstep, fmu_min;
  void alphas_nf5(double, int, int);

};
