#pragma once
#include<vector>

using namespace std;


template<class T>
T Min(T a1, T a2) {
  T res = a2;
  if(a1<a2) res = a1;
  return res;
}

template<class T>
T Max(T a1, T a2) {
  T res = a2;
  if(a1>a2) res = a1;
  return res;
}

template<class T>
T Min(vector<T> a) {
  T res = a[0];
  for(int i=1; i<a.size(); i++) {
    if(a[i]<res) res = a[i];
  }
  return res;
}

template<class T>
T Max(vector<T> a) {
  T res = a[0];
  for(int i=1; i<a.size(); i++) {
    if(a[i]>res) res = a[i];
  }
  return res;
}

template<class T>
T Min(T *a, int dim, int *imin=NULL) {
  T res = a[0];
  int im = 0;
  for(int i=1; i<dim; i++) {
    if(a[i]<res) {
      res = a[i];
      im = i;
    }
  }
  if(imin != NULL) *imin = im;
  return res;
}

template<class T>
T Max(T *a, int dim, int *imax=NULL) {
  T res = a[0];
  int im = 0;
  for(int i=1; i<dim; i++) {
    if(a[i]>res) {
      res = a[i];
      im = i;
    }
  }
  if(imax != NULL) *imax = im;
  return res;
}

template<class T>
inline T SQR(T a) {
  return a*a;
}

template<class T>
inline T theta(T a) {
  if(a>=0) return 1;
  return 0;
}

template<class T>
bool AllSignsPlus(vector<T> a) {
  for(int i=0; i<a.size(); i++) {
    if(a[i]<0) return false;
  }
  return true;
}
template<class T>
bool SameSigns(vector<T> a) {
  if(a.size()<=1) return true;
  int s = (a[0]>0 ? 1 : -1);
  for(int i=1; i<a.size(); i++) {
    if(s*a[i]<0) return false;
  }
  return true;
}

template<class T>
bool AlternatingSigns(vector<T> a) {
  if(a.size()<=1) return true;
  int s = (a[0]>0 ? 1 : -1);
  for(int i=1; i<a.size(); i++) {
    if(s*pow(-1,i)*a[i]<0) return false;
  }
  return true;
}
template<class T>
bool AlternatingSigns(vector<T> a, int &offset) {
  offset = 0;
  if(a.size()<=1) return true;
  int s = (a[0]>0 ? 1 : -1);
  if(s*a[1]>0) offset = 1; // sings start to alternate from the second order
  //if(a.size()==2) return true;
  for(int i=2; i<a.size(); i++) {
    if(s*pow(-1,i+offset)*a[i]<0) return false;
  }
  return true;
}

template<class T>
inline int sign(T a) {
  if(a<0) return -1;
  return 1;
}

