#include <iostream>
#include <iomanip>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <gsl/gsl_integration.h>

#include "integration.hh"


using namespace std;




////////////////////////////////////////////////////////////
// INTEGRALS                                              //
////////////////////////////////////////////////////////////


double integration::gauss(double f(double,void*), double xmin, double xmax, double prec, double *error, void *par){
  double result, err;
  gsl_function F;
  gsl_integration_workspace * w = gsl_integration_workspace_alloc (1000);
  F.function = f;
  F.params=par;
  //gsl_integration_qag  (&F, xmin, xmax, 0, prec, 1000, 2, w, &result, &err);
  gsl_integration_qag  (&F, xmin, xmax, 0, prec, 1000, 6, w, &result, &err);
  //gsl_integration_qags (&F, xmin, xmax, 0, prec, 1000,    w, &result, &err);
  gsl_integration_workspace_free (w);
  if(error) *error = err;
  return result;
}

double integration::gauss_inf(double f(double,void*), double xmin, double prec, double *error, void *par){
  double result, err;
  gsl_function F;
  gsl_integration_workspace * w = gsl_integration_workspace_alloc (100000);
  F.function = f;
  F.params=par;
  gsl_integration_qagiu (&F, xmin, 0, prec, 100000, w, &result, &err);
  gsl_integration_workspace_free (w);
  if(error) *error = err;
  return result;
}

double integration::gauss_inf2(double f(double,void*), double prec, double *error, void *par){
  double result, err;
  gsl_function F;
  gsl_integration_workspace * w = gsl_integration_workspace_alloc (100000);
  F.function = f;
  F.params=par;
  gsl_integration_qagi (&F, 0, prec, 100000, w, &result, &err);
  gsl_integration_workspace_free (w);
  if(error) *error = err;
  return result;
}

double integration::gauss_sing(double f(double,void*), double xmin, double xmax, double sing, double prec, double *error, void *par){
  double result, err;
  gsl_function F;
  gsl_integration_workspace * w = gsl_integration_workspace_alloc (100000);
  F.function = f;
  F.params=par;
  gsl_integration_qawc (&F, xmin, xmax, sing, 0, prec, 100000, w, &result, &err);
  gsl_integration_workspace_free (w);
  if(error) *error = err;
  return result;
}
